﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Controls.Schedules;
using Infragistics.Collections;
using System.Collections;

namespace GetActivities
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<Resource> resources = new ObservableCollection<Resource>();
        ObservableCollection<ResourceCalendar> calendars = new ObservableCollection<ResourceCalendar>();
        ObservableCollection<Appointment> appointments = new ObservableCollection<Appointment>();
        ObservableCollection<Task> tasks = new ObservableCollection<Task>();

        public MainWindow()
        {
            InitializeComponent();
            dayView.CalendarDisplayMode = CalendarDisplayMode.Overlay;

        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            resources.Add(new Resource
            {
                Id = "own1",
                Name = "Amanda"
            });

            resources.Add(new Resource
            {
                Id = "own2",
                Name = "Brian"
            });


            calendars.Add(new ResourceCalendar
            {
                Id = "cal1",
                OwningResourceId = "own1"
            });

            calendars.Add(new ResourceCalendar
            {
                Id = "cal2",
                OwningResourceId = "own2"
            });


            Appointment myReccAppointment = new Appointment
            {
                Id = "t" + 2,
                OwningCalendarId = "cal2",
                OwningResourceId = "own2",
                Subject = "Reccurent App ALL Day",
                Description = "My  Reccurent App " + 1,
                Start = DateTime.Now,
                End = DateTime.Now.AddMinutes(15),
                //IsTimeZoneNeutral = true
            };

            Appointment myReccAppointment2 = new Appointment
            {
                Id = "t2" + 2,
                OwningCalendarId = "cal2",
                OwningResourceId = "own2",
                Subject = "Reccurent App 2",
                Description = "My  Reccurent App " + 1,
                Start = DateTime.Now,
                End = DateTime.Now.AddMinutes(15),
                IsTimeZoneNeutral = true
            };

            DateRecurrence rec = new DateRecurrence();
            rec.Count = 10;
            rec.Frequency = DateRecurrenceFrequency.Monthly;
            rec.Interval = 1;
            var recuRules = new List<DateRecurrenceRuleBase>();
            rec.Rules.Add(new DayOfWeekRecurrenceRule(DayOfWeek.Monday, 0));
            rec.Rules.Add(new DayOfWeekRecurrenceRule(DayOfWeek.Tuesday, 0));
            rec.Rules.Add(new DayOfWeekRecurrenceRule(DayOfWeek.Wednesday, 0));
            rec.Rules.Add(new DayOfWeekRecurrenceRule(DayOfWeek.Thursday, 0));
            rec.Rules.Add(new DayOfWeekRecurrenceRule(DayOfWeek.Friday, 0));
            rec.Rules.Add(new DayOfWeekRecurrenceRule(DayOfWeek.Saturday, 0));
            rec.Rules.Add(new DayOfWeekRecurrenceRule(DayOfWeek.Sunday, 0));
            rec.Rules.Add(new SubsetRecurrenceRule { OccurrenceInstance = -1 });
            myReccAppointment.Recurrence = rec;

            appointments.Add(myReccAppointment);
            appointments.Add(myReccAppointment2);

            //===================== Setting the time zone to the local time zone ==============================//
            dataConnector.TimeZoneInfoProviderResolved.LocalTimeZoneId = TimeZone.CurrentTimeZone.StandardName;
            // ================================================================================================//
            dataConnector.ResourceItemsSource = resources;
            dataConnector.ResourceCalendarItemsSource = calendars;
            dataConnector.AppointmentItemsSource = appointments;
            dataConnector.TaskItemsSource = tasks;

        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            //var result = dataManager.GetActivities(new ActivityQuery(
            //    ActivityTypes.Appointment,
            //    new Infragistics.DateRange(DateTime.Now.AddDays(-1), DateTime.Now.AddDays(11)),
            //    calendars[0]));
            Appointment myReccAppointment3 = new Appointment
            {
                Id = "t4" + 2,
                OwningCalendarId = "cal1",
                OwningResourceId = "own1",
                Subject = "Reccurent App 2",
                Description = "My  Reccurent App " + 1,
                Start = DateTime.Now,
                End = DateTime.Now.AddMinutes(15),
                IsTimeZoneNeutral = true
            };

            Appointment app1 = new Appointment()
            {
                Id = "ID1",
                OwningResourceId = "own1",
                OwningCalendarId = "cal1",
                Subject = " test Appointment 1",
                Description = "My first test appointment",
                // Convert the date to universal time, because a time zone is not set
                // in this snippet    
                //Start = DateTime.Now,
                //End = DateTime.Now.AddMinutes(15),
                Start = DateTime.Today.AddHours(24).AddMinutes(12).ToUniversalTime(),
                End = DateTime.Today.AddHours(24).AddMinutes(42).ToUniversalTime(),

                //IsTimeZoneNeutral = true
            };

            //((ObservableCollection<Appointment>)dataConnector.AppointmentItemsSource).Add(app1);
            //dataManager.DisplayActivityDialog(app1, this);
            //var result1 = ((ObservableCollection<Appointment>)dataConnector.AppointmentItemsSource).Where(a => a. OwningResourceId == "History" ).ToList().Count;
            //string activities = "";
            //int i = 1;
            //foreach (Appointment app in result.Activities)
            //{
            //    activities += i + ": " + app.Subject + "\n";
            //    i++;
            //}
            //MessageBox.Show(activities);
        }
    }

}